<template>
	<v-dialog
		v-if="dialog"
		v-model="dialog"
		:fullscreen="$vuetify.breakpoint.smAndDown"
		max-width="60%"
	>
		<task-detail v-model="task" @close="closeDialog" />
	</v-dialog>
</template>

<script>
import TaskDetail from "@/components/TaskDetail";
import taskService from "@/mixins/TaskService";

export default {
	components: {
		TaskDetail
	},

	mixins: [taskService],

	props: {
		id: {
			type: Number,
			required: true
		}
	},

	data() {
		return {
			task: null,
			dialog: false,
			deleteDialog: false,
			edit: false
		};
	},

	watch: {
		dialog(newValue) {
			if (!newValue) {
				this.$router.back();
			}
		}
	},

	mounted() {
		this.findTask().then(this.openDialog);
	},

	destroyed() {
		this.closeDialog();
	},

	beforeRouteUpdate(to, from, next) {
		this.findTask().then(next);
	},

	methods: {
		findTask() {
			return this.taskService.find(this.id).then(t => (this.task = t));
		},

		openDialog() {
			this.dialog = true;
		},

		closeDialog() {
			this.dialog = false;
		}
	}
};
</script>
